<?php

namespace App\Http\Controllers;
use App\Gallery;
use App\indexblog;
use App\IndexBook;
use App\IndexInfo;
use App\Info;
use App\Map;
use App\Team;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class HomeController extends Controller {
	/**
	 * Create a new controller instance.
	 *
	 * @return void
	 */
	public function __construct() {
		$this->middleware('auth');
	}

	/**
	 * Show the application dashboard.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function index() {
		return view('backend.home');
	}

	public function Edit_info() {
		return view('backend.edit_info');
	}
	public function Edit_title() {
		$data = DB::table('info_site')->where('id', '1')->get();
		return view('backend.edit_title', ['data' => $data[0]]);
	}
	public function Edit_info_success(Request $request) {
		$data = new Info();
		$data = Info::find('1');
		$data->title = $request->input('title');
		$data->keyword = $request->input('keyword');
		$data->save();
		return view('backend.edit_info');

	}
	public function Edit_img() {
		$data = DB::table('info_site')->where('id', '1')->get();
		return view('backend.image_banner', ['data' => $data[0]]);
	}
	public function Edit_img_success(Request $request) {
		$data = new Info();
		$data = Info::find('1');

		if ($request->hasFile('image1')) {
			$image1 = $request->file('image1');
			$path1 = public_path() . '/images/';
			$filename1 = time() . '.' . $image1->getClientOriginalExtension();
			$image1->move($path1, $filename1);
			$data->image1 = '/images/' . $filename1;
		}

		$data->save();

		return view('backend.edit_info');

	}
	public function Edit_about() {
		$data = DB::table('info_site')->where('id', '1')->get();

		return view('backend.edit_about', ['data' => $data[0]]);
	}
	public function Edit_about_success(Request $request) {
		$data = new Info();
		$data = Info::find('1');
		$data->about = $request->input('about');
		$data->address = $request->input('add');
		$data->phone = $request->input('phone');

		$data->page = $request->input('page');
		$data->save();
		return view('backend.edit_info');

	}
	public function indexBlog() {
		return view('backend.indexblog');

	}
	public function indexBlog_add() {
		return view('backend.indexblog_add');
	}
	public function indexBlog_sucess(Request $request) {
		$data = new IndexBlog();
		if ($request->hasFile('image')) {
			$image = $request->file('image');
			$path = public_path() . '/images/';
			$filename = time() . '.' . $image->getClientOriginalExtension();
			$image->move($path, $filename);
			$data->image = '/images/' . $filename;
		}
		$data->title = $request->input('title');
		$data->content = $request->input('content');
		$data->blog = $request->input('blog');
		$data->save();

		return view('backend.indexblog');

	}
	public function indexBlog_list() {
		$data = DB::table('index_blog')->get();
		return view('backend.indexblog_list', ['data' => $data]);
	}

	public function indexinfo() {
		$data1 = DB::table('index_info')->where('id', '1')->get();
		return view('backend.indexinfo', ['data1' => $data1[0]]);
	}
	public function indexInfo_success(Request $request) {
		$data = new IndexInfo();
		$data = IndexInfo::find('1');
		$data->welcome = $request->input('welcome');
		$data->khachhang = $request->input('kh');
		$data->ytuong = $request->input('yt');
		$data->dichvu = $request->input('sk');
		$data->lecuoi = $request->input('lc');
		$data->anhoi = $request->input('lah');
		$data->save();

		$data1 = DB::table('index_info')->where('id', '1')->get();
		return view('backend.indexinfo', ['data1' => $data1[0]]);

	}
	public function indexBook() {
		$data = DB::table('index_book')->get();
		return view('backend.indexbook', ['data' => $data]);
	}
	public function indexCheck($id) {
		$check = new IndexBook();
		$check = IndexBook::find($id);
		$check->very = '1';
		$check->save();
		$data = DB::table('index_book')->get();
		return view('backend.indexbook', ['data' => $data]);
	}
	public function team() {
		$data = DB::table('team')->get();
		return view('backend.team', ['data' => $data]);
	}
	public function team_add(Request $request) {
		$data = new Team();
		if ($request->hasFile('image')) {
			$image = $request->file('image');
			$path = public_path() . '/images/';
			$filename = time() . '.' . $image->getClientOriginalExtension();
			$image->move($path, $filename);
			$data->avatar = '/images/' . $filename;
		}
		$data->fullname = $request->input('fullname');
		$data->facebook = $request->input('facebook');
		$data->save();

		$data2 = DB::table('team')->get();
		return view('backend.team', ['data' => $data2]);

	}
	public function gallery() {
		return view('backend.gallery');
	}
	public function gallery_add(Request $request) {
		$data = new Gallery();
		if ($request->hasFile('image')) {
			$image = $request->file('image');
			$path = public_path() . '/images/';
			$filename = time() . '.' . $image->getClientOriginalExtension();
			$image->move($path, $filename);
			$data->image = '/images/' . $filename;
		}
		$data->mota = $request->input('des');
		$data->save();
		return redirect('/home/gallery');

	}
	public function gallery_list() {
		$data = DB::table('gallery')->paginate(8);
		return view('backend.gallery_list', ['data' => $data]);

	}
	public function gallery_del($id) {
		$data1 = DB::table('gallery')->where('id', $id)->delete();
		$data = DB::table('gallery')->paginate(8);
		return view('backend.gallery_list', ['data' => $data]);
	}
	public function team_del($id) {
		$data1 = DB::table('team')->where('id', $id)->delete();
		$data2 = DB::table('team')->get();
		return view('backend.team', ['data' => $data2]);

	}
	public function contact() {
		$data = DB::table('contact')->get();
		$data = $data[0];
		return view('backend.contact', ['data' => $data]);
	}
	public function contact_ed(Request $request) {
		$data = new Map();
		$data = Map::find('1');
		$data->map = $request->input('map');
		$data->save();
		return redirect('/home/contact');
	}
}
